import fs from "fs";
import JSONFile from "./json/test-data.json" assert { type: "json" };

// Function to generate Vue component files
function generateComponentFiles() {
  JSONFile.forEach(obj => {
    const componentContent = generateComponentContent(obj, false);
    const filePath = `components/${obj.name.toLowerCase().replace(/ /g, "-")}.vue`;

    fs.writeFileSync(filePath, componentContent);

    console.log(`Generated ${filePath}\n`);
  });
}

// Choose HTML Element
// function chooseElement(ele) {
//   let el = 

//   switch (key) {
//     case value:
      
//       break;
  
//     default:
//       break;
//   }

//   return el;
// }

// Function to generate Vue component content
function generateComponentContent(obj, isChild) {
  let el = `
    <${obj.el} 
      id="${obj?.id ? obj.id : ""}" 
      class="${obj?.class ? obj.class : ""}" 
      ${obj?.condition?.if ? `v-if="${obj?.condition?.if}"` : ""}
    >
      ${obj?.children?.length ? obj?.children.map(child => generateComponentContent(child, true)) : ""}
      ${obj?.text ? obj?.text : ""}
      ${obj?.d_text ? `{{${obj?.d_text}}}` : ""}
    </${obj.el}>
  `;
  
  if(!isChild) {
    el = `
  <template>${el}</template>

  <script>
  export default {
    name: "${obj.name.replace(/ /g, "")}",
    props: ${JSON.stringify(obj.props)},
    ${obj.data ? `
    data() {
      return {...${JSON.stringify(obj.data)}}
    } ` : ""}
  };
  </script>
  `
  }

  return el;
}

generateComponentFiles();

/* 
{
    "el": "div",
    "id": "address-name",
    "text": "SubOrderDetails ShipToName"
  },
  {
    "el": "div",
    "text": "Address on file"
  },
  {
    "el": "div",
    "id": "address-name",
    "text": "SubOrderDetails FullName"
  },
  {
    "el": "div",
    "text": "SubOrderDetails AddrLine1"
  },
  {
    "el": "div",
    "text": "SubOrderDetails AddrLine2"
  },
  {
    "el": "div",
    "text": "SubOrderDetails City, SubOrderDetails StateProvince, SubOrderDetails FullPostalCode"
  },
  {
    "el": "div",
    "text": "SubOrderDetails DayPhone"
  },
  {
    "el": "div",
    "text": "SubOrderDetails EveningPhone"
  },
  {
    "el": "div",
    "class": "review",
    "text": "SubOrderDetails PlainEmailAddr"
  },
  {
    "el": "div",
    "class": "review",
    "text": "profileEmail"
  }

*/